Use Windows.pkg
Use DFClient.pkg
Use cSigCjLabel.pkg
Use SigCjW_MarkupLabel.pkg
Use Processmessages.pkg
Use cCJGrid.pkg
Use cCJGridColumn.pkg

Deferred_View Activate_oSIGCJXamlInteractiveDemo_View for ;
Object oSIGCJXamlInteractiveDemo_View is a dbView

    Set Border_Style to Border_Thick
    Set Size to 200 443
    Set Location to 2 2
    Set Maximize_Icon to True
    Set Label to "Codejock Demo - Interactive Xaml"
    Set Icon to "SIG.ico"
    
    Function Read_xaml String sFileName Returns String
        String  sRetval  sLine
        Boolean bExists
        Integer iChannel
    
        File_Exist sFileName bExists
        If (not(bExists)) Begin
            Function_Return "Error:- File not found"
        End
    
        Get Seq_New_Channel to iChannel
    
        Direct_Input channel iChannel sFileName
        If (SeqEof) Begin
            Close_Input channel iChannel
            Send Seq_Release_Channel iChannel
            Function_Return "Error:- File has no data"
        End

        While (not(SeqEof))
            Readln channel iChannel sLine
            Move (Append(sRetval,sLine)) to sRetval
        Loop
        If (SeqEof) Begin
            Close_Input channel iChannel
        End
        
        Send Seq_Release_Channel iChannel
        Function_Return sRetval
    End_Function

    Function InteractiveXamlFileName integer iItem Returns String
        Handle hoWorkspace
        String sFilePath
        String sHomePath sMarkupPath
    
        Get phoWorkspace of oApplication to hoWorkspace
        Get psHome       of hoWorkspace  to sHomePath
    
        Move (sHomePath + 'Markup\') To sMarkupPath
        If (iItem=0) Begin
          Move (sMarkupPath+"InteractiveOutlookPaneGridCell.xaml") to sFilePath
          //Move (sMarkupPath+"InterActiveSecurityCenterSample.xaml") To sFilePath
          
        End
        Else If (iItem=1) Begin
          Move (sMarkupPath+"Math.xaml") To sFilePath
        End
        Function_Return sFilePath
    End_Function

  Object oCJGrid1 is a cCJGrid
    Set Size to 438 436
    Set Location to 32 6
    Set pbShowHeader              to False // Don't display a column header
    Set pbSelectionEnable         to False // Don't visually select the whole row
    Set peAnchors                 to anAll
    Set pbEditOnKeyNavigation     to False
    Set pbEditOnClick             to False
    Set pbReadOnly                to True
    Set pbFocusSubItems           to True
    Set pbHeaderReorders          to False
    Set pbHeaderTogglesDirection  to False
    Set pbHeaderSelectsColumn     to True
    Set peHorizontalGridStyle     to xtpGridNoLines
    Set peVerticalGridStyle       To xtpGridNoLines // no vertical lines between the images.
    //Set pbAutoColumnSizing        to False

    Object oCJGridColumn1 is a cCJGridColumn
      Set piWidth to 272
      Set psCaption to "column"
      Set pbMultiLine to True
      Set pbFocusable to True
    End_Object


    Procedure OnCreate
        Handle hoMarkUpContext
        Variant vMarkUpContext

        Forward Send OnCreate
        
        // As we use markup, we have to enable it and do so early on
        Set ComEnableMarkup to True
        
        //Get ComMarkupContext to vMarkUpContext
        //Get Create (RefClass(cSigCjComMarkupContext)) to hoMarkUpContext
        //Set pvComObject of hoMarkUpContext to vMarkUpContext
        //
        //Send Destroy of hoMarkUpContext
    End_Procedure
    
    Procedure FillRows
        Handle hoDataSource
        tDataSourceRow[] TheData
        
        Get phoDataSource to hoDataSource
    
        Move "1" to TheData[0].sValue[0]
        //Move "2" to TheData[1].sValue[0]
        
        // Initialize Grid with new data
        Send InitializeData TheData
    End_Procedure
      
    
    Procedure DisplayMarkup
      Handle  hoRecord
      Handle  hoRecords
      Handle  hoRecordItem
      //Handle  hoMarkupContext
      //Integer iVoid
      Integer iCell
      Integer iCellCount
      //Integer iGroupByColumn
      Integer iRecordCount
      Integer iRecord
      //Integer iImageID
      //Integer iItem
      //Integer iIconPos
      //Integer iIconCrop
      String  sMarkup
      //String  sImage
      String  sFileName
      //String  sImageDate
      //String  sPos
      Variant vRecord
      Variant vRecords
      Variant vRecordItem

      Get ComRecords to vRecords
      Get Create (RefClass(cCJReportRecords)) to hoRecords
      If (hoRecords) Begin
        Set pvComObject of hoRecords to vRecords
        Get ComCount    of hoRecords to iRecordCount
        For iRecord from 0 to (iRecordCount-1)
          Get ComRecord of hoRecords iRecord to vRecord
          Get Create (RefClass(cCJReportRecord)) to hoRecord
          If (hoRecord) Begin
            Set pvComObject of hoRecord to vRecord
            Get ComItemCount of hoRecord to iCellCount
            For iCell from 0 to (iCellCount-1)
              Get ComItem of hoRecord iCell to vRecordItem
              Get Create (RefClass(cCJReportRecordItem)) to hoRecordItem
              If (hoRecordItem) Begin
                Set pvComObject of hoRecordItem to vRecordItem
                //If (iRecord=1) Begin
                  Get InteractiveXamlFileName iRecord to sFileName
                  Get Read_xaml sFileName to sMarkup
                  Set ComCaption of hoRecordItem to sMarkup
                //End
                //Else Set ComCaption of hoRecordItem to ""

                Send Destroy of hoRecordItem
              End
            Loop
            Send Destroy of hoRecord
          End
        Loop
        Send Destroy of hoRecords
      End
    End_Procedure
    
    Procedure LoadData
      
      Send ComClearContent
      
      Send Cursor_Wait Of Cursor_Control
      Send FillRows
      Send DisplayMarkup
      Send ComPopulate
      Send Cursor_Ready of Cursor_Control
    End_Procedure
    
    Procedure Activating
      Forward Send Activating
      Send LoadData
    End_Procedure
    
    Procedure TriggerDrafts Integer iItem
      Send info_Box "drafts"
    End_Procedure
    
    Procedure TriggerSent Integer iItem
      Send info_box "sent"
    End_Procedure
    
    Procedure TriggerInbox Integer iItem
      Send info_box "inbox"
    End_Procedure
    
    Procedure TriggerJunk Integer iItem
      Send info_box "junk"
    End_Procedure
    
    Procedure MarkupObjectMouseOverTrigger Handle hoMarkup String sName Integer iMessage Integer iItem
      Boolean bIsMouseOver
      Handle  hoMarkupObject
      Variant vMarkupObject
      
      Get ComFindName of hoMarkup sName to vMarkupObject
      If (IsComObject(vMarkupObject)) Begin
        Get Create (RefClass(cCJMarkupUIElement)) to hoMarkupObject
        If (hoMarkupObject) Begin
          Set pvComObject of hoMarkupObject to vMarkupObject
          Get ComIsMouseOver of hoMarkupObject to bIsMouseOver
          If (bIsMouseOver and iMessage<>0) Begin
            Send iMessage iItem
          End
          Send Destroy of hoMarkupObject
        End
      End
    End_Procedure
    
    Procedure OnItemClick Variant llItem // Variant llRow Variant llColumn
      Boolean bMarkupEnabled
      Handle  hoReportItem
      Handle  hoMarkup
      Integer iItem
      Variant vMarkup
      If (IsComObject(llItem)) Begin
        Get Create (RefClass(cCJReportRecordItem)) to hoReportItem
        If (hoReportItem) Begin
          Set pvComObject of hoReportItem to llItem
          Get ComValue of hoReportItem to iItem
          Get ComEnableMarkup to bMarkupEnabled
          If (iItem>-1 and bMarkupEnabled) Begin
            Get ComMarkupUIElement of hoReportItem to vMarkup
            If (IsComObject(vMarkup)) Begin
              Get Create (RefClass(cCJMarkupUIElement)) to hoMarkup
              If (hoMarkup) Begin
                Set pvComObject of hoMarkup to vMarkup
                Send MarkupObjectMouseOverTrigger hoMarkup "Drafts"  msg_TriggerDrafts iItem
                Send MarkupObjectMouseOverTrigger hoMarkup "Sent"    msg_TriggerSent   iItem
                Send MarkupObjectMouseOverTrigger hoMarkup "Inbox"   msg_TriggerInbox  iItem
                Send MarkupObjectMouseOverTrigger hoMarkup "Junk"    msg_TriggerJunk   iItem
                Send Destroy of hoMarkup
              End
            End
          End
          Send Destroy of hoReportItem
        End
      End
    End_Procedure
  
  
    // augment to handle mouse click
    Procedure OnComMouseUp Short llButton Short llShift Integer llx Integer lly
        Handle  hoHitTest
        Integer eHt
        Variant vHit vItem
        
        Forward Send OnComMouseUp llButton llShift llx lly
  
        Get ComHitTest llx lly to vHit
        Get Create (RefClass(cCJReportHitTestInfo)) to hoHitTest
        If (hoHitTest and IsComObject(vHit)) Begin
          Set pvComObject of hoHitTest to vHit
          Get ComHt       of hoHitTest to eHt
          If (eHt=xtpHitTestReportArea) Begin
            If (llButton=1) Begin    // 1=left mouse button, 2=right mouse
              Get ComItem of hoHitTest  to vItem
              If (IsComObject(vItem)) Begin
                Send OnItemClick vItem
              End
            End
          End
        End
        If (hoHitTest) Send Destroy of hoHitTest
    End_Procedure


  End_Object

Cd_End_Object
