Use Windows.pkg
Use DFClient.pkg
Use cSigCjLabel.pkg
Use SigCjW_MarkupLabel.pkg
Use Processmessages.pkg

Class cMyJMarkupLabel Is a  cSigCjComMarkupLabel
   Procedure Construct_Object
      Forward Send Construct_Object

      //Set External_Class_Name "cDFMarkupLabel" To "AfxOleControl42"
      Set External_Class_Name "cDFMarkupLabel" To "#32770" //"static"

      Set External_Message WM_LBUTTONDOWN To OnSplitterMouseDown
      //Set External_Message WM_LBUTTONUP To OnSplitterMouseUp
      //Set External_Message WM_MOUSEMOVE To OnSplitterMouseMove
   End_Procedure // Construct_Object

   Procedure OnSplitterMouseDown Integer wParam Integer lParam
     send info_Box "mouse down"
   End_Procedure

End_Class

Deferred_View Activate_oSIGCJXamlInteractiveDemoLabel_View for ;
Object oSIGCJXamlInteractiveDemoLabel_View is a dbView

    Set Border_Style to Border_Thick
    Set Size to 200 300
    Set Location to 2 2
    Set Maximize_Icon to True
    Set Label to "Codejock Demo - Interactive Xaml (LABEL)"
    Set Icon to "SIG.ico"
    
    Function Read_xaml String sFileName Returns String
        String  sRetval  sLine
        Boolean bExists
        Integer iChannel
    
        File_Exist sFileName bExists
        If (not(bExists)) Begin
            Function_Return "Error:- File not found"
        End
    
        Get Seq_New_Channel to iChannel
    
        Direct_Input channel iChannel sFileName
        If (SeqEof) Begin
            Close_Input channel iChannel
            Send Seq_Release_Channel iChannel
            Function_Return "Error:- File has no data"
        End

        While (not(SeqEof))
            Readln channel iChannel sLine
            Move (Append(sRetval,sLine)) to sRetval
        Loop
        If (SeqEof) Begin
            Close_Input channel iChannel
        End
        
        Send Seq_Release_Channel iChannel
        Function_Return sRetval
    End_Function

    Function InteractiveXamlFileName Returns String
        Handle hoWorkspace
        String sFilePath
        String sHomePath sMarkupPath
    
        Get phoWorkspace of oApplication to hoWorkspace
        Get psHome       of hoWorkspace  to sHomePath
    
        Move (sHomePath + 'Markup\') to sMarkupPath
        Move (sMarkupPath+"InteractiveOutlookPane.xaml") To sFilePath
        Function_Return sFilePath
    End_Function

    Object oButton1 is a Button
        Set Size to 14 35
        Set Location to 8 253
        Set Label to "Dummy"
    
        Procedure OnClick
            Send Info_Box "This is a dummy object that we need to give the focus after each click.. silly ugly workaround"
        End_Procedure
    
    End_Object


    Object oSigCJLabel1 is a cSigCjComMarkupLabel // cSigCJLabel 
        Set Size to 250 400
        Set Location to 32 6
        Set peAnchors to anAll
        
        Property Handle phoUIElement  0
        
    
        Procedure OnCreate
            Handle hoMarkUpContext
            Handle hoUIElement
            Handle hoMarkupObject
            String sFileName
            String sMarkup
            Variant vMarkUpContext
            Variant vUIElement
            Variant vMouseClick
            Variant vMarkupObject
    
            Forward Send OnCreate
            
            Get ComMarkupContext to vMarkUpContext
// Eeks don't use the non cSigCJ version here as the RT might use another codejock 
// version and it will be very painful to debug.
//            Get Create U_cCjMarkupContext to hoMarkUpContext
            Get Create (Refclass(cSigCjComMarkupContext)) to hoMarkUpContext
            Set pvComObject of hoMarkUpContext to vMarkUpContext
    
            
            Get InteractiveXamlFileName to sFileName
            Get Read_xaml sFileName to sMarkup
            
            Set ComCaption to sMarkup
            Get ComMarkupUIElement to vUIElement
            If (IsComObject(vUIElement)) Begin
              //Get Create (RefClass(cSigCjComMarkupVisual)) to hoVisual
              Get Create (RefClass(cSigCjComMarkupUIElement)) to hoUIElement
              If hoUIElement Begin
                Set pvComObject of hoUIElement to vUIElement
                Set phoUIElement to hoUIElement

                Get ComMouseLeftButtonUpEvent of hoUIElement to vMouseClick
                //Send ComSetHandler of hoMarkUpContext vUIElement //vMarkUpContext
                //Send ComSetMethod  of hoMarkUpContext vUIElement "TestClick"
                ////
                //Send ComAddHandler of hoVisual vMouseClick "Mouse_Up"
                //
                // Below is one of MANY attempts I tried to hook up the routed events
                //  Above is another attempt commented out
                // For the record this below DOES NOT WORK!
                // We cannot catch an event on a hyperlink object or a button object or a radio group
                // or ... but it does work for text and images.
                Get ComFindName of hoUIElement "this" to vMarkupObject
                If (IsComObject(vMarkupObject)) Begin
                  Get Create (RefClass(cSigCjComMarkupHyperlink)) to hoMarkupObject
                  If (hoMarkupObject) Begin
                    Set pvComObject of hoMarkupObject to vMarkupObject
                    Send ComAddHandler of hoMarkupObject vMouseClick "TestClick"
                    Send Destroy of hoMarkupObject
                  End
                End
                

              End
            End
            Send Destroy of hoMarkUpContext
        End_Procedure
        
        Procedure OnEnterObject Handle hoFrom
          Handle hoUIElement
          Forward Send OnEnterObject hoFrom
          Get phoUIElement to hoUIElement 
          If (hoUIElement) Begin
            //Send ComCaptureMouse of hoUIElement
            Send Fake_Mouse_Up
            Send Activate of oButton1 // MUST put focus elsewhere after our "mouse_up" simulation or it won't click again!
          End
        End_Procedure
        
        Procedure OnExitObject 
          Handle hoUIElement
          Get phoUIElement to hoUIElement 
          If (hoUIElement) Begin
            //Send ComReleaseMouseCapture of hoUIElement
          End
          Forward Send OnExitObject
        End_Procedure
      
        Procedure Fake_Mouse_Up
          Boolean bIsMouseOver
          Boolean bMarkupEnabled
          Handle  hoMarkupObject
          Integer iItem
          Variant vMarkup
          Variant vMarkupObject
          Handle hoUIElement
          
          Get phoUIElement to hoUIElement 
          If (hoUIElement) Begin
            Get ComFindName of hoUIElement "Drafts" to vMarkupObject
            If (IsComObject(vMarkupObject)) Begin
              Get Create (RefClass(cSigCJComMarkupUIElement)) to hoMarkupObject
              If (hoMarkupObject) Begin
                Set pvComObject of hoMarkupObject to vMarkupObject
                Get ComIsMouseOver of hoMarkupObject to bIsMouseOver
                If (bIsMouseOver) Begin
                  Send info_Box "drafts was clicked"
                End
                Send Destroy of hoMarkupObject
              End
            End
            Get ComFindName of hoUIElement "Junk" to vMarkupObject
            If (IsComObject(vMarkupObject)) Begin
              Get Create (RefClass(cSigCJComMarkupUIElement)) to hoMarkupObject
              If (hoMarkupObject) Begin
                Set pvComObject of hoMarkupObject to vMarkupObject
                Get ComIsMouseOver of hoMarkupObject to bIsMouseOver
                If (bIsMouseOver) Begin
                  Send info_Box "junk was clicked"
                End
                Send Destroy of hoMarkupObject
              End
            End
          End
        End_Procedure

    
        Procedure TestClick
            Send Info_Box "Link Clicked"
        End_Procedure
    
        Procedure MakeShapeRed
            Send Info_Box "Hello MakeShapeRed"
        End_Procedure
    
        Procedure MakeShapeGreen
            Send Info_Box "Hello MakeShapeGreen"
        End_Procedure
    
    End_Object

Cd_End_Object
